//------------------------------------------------------------------

   #property copyright "mladen"
   #property link      "www.forex-tsd.com"

//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_plots   4
#property indicator_type1   DRAW_COLOR_HISTOGRAM
#property indicator_color1  DeepSkyBlue,PowderBlue,Red,Pink
#property indicator_width1  3
#property indicator_type2   DRAW_LINE
#property indicator_color2  Silver
#property indicator_width2  2
#property indicator_type3   DRAW_LINE
#property indicator_color3  Gold
#property indicator_width3  1
#property indicator_type4   DRAW_LINE
#property indicator_color4  Orange
#property indicator_width4  2

//
//
//
//
//

input int                MaLength     = 2;              // Price pre-smoothing period 
input int                Depth        = 10;             // Depth of calculation
input double             SignalSmooth = 30;             // Smooth signal
input double             RmoSmooth    = 81;             // Smooth RMO
input ENUM_APPLIED_PRICE Price        = PRICE_CLOSE;    // Price to use
input bool               SignaLinesVisible = true;      // Signal lines visible ? 

//
//
//
//
//

double rmo[];
double rmoLine[];
double rmoSignal1[];
double rmoSignal2[];
double colorBuffer[];
double prices[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,rmo,INDICATOR_DATA);        PlotIndexSetString(0,PLOT_LABEL,"RMO");
   SetIndexBuffer(1,colorBuffer,INDICATOR_COLOR_INDEX); 
   SetIndexBuffer(2,rmoLine,INDICATOR_DATA);    PlotIndexSetString(1,PLOT_LABEL,"RMO");
   SetIndexBuffer(3,rmoSignal1,INDICATOR_DATA); PlotIndexSetString(2,PLOT_LABEL,"RMO signal 1"); PlotIndexSetInteger(2,PLOT_SHOW_DATA,SignaLinesVisible);
   SetIndexBuffer(4,rmoSignal2,INDICATOR_DATA); PlotIndexSetString(3,PLOT_LABEL,"RMO signal 2"); PlotIndexSetInteger(3,PLOT_SHOW_DATA,SignaLinesVisible);
   SetIndexBuffer(5,prices,INDICATOR_CALCULATIONS); 
      IndicatorSetString(INDICATOR_SHORTNAME,"RMO ("+string(Depth)+","+(string)+SignalSmooth+","+(string)RmoSmooth+")");
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define MAX_depth 50
double  pBuffer[][MAX_depth];
double  work[][2];

//
//
//
//
//

int OnCalculate(const int rates_total, const int prev_calculated,
                const datetime& time[],
                const double& open[], const double& high[], const double& low[], const double& close[],
                const long& tick_volume[],const long& volume[],
                const int& spread[])
{
   if (ArrayRange(pBuffer,0) != rates_total)
   {
      ArrayResize(pBuffer,rates_total);
      ArrayResize(work   ,rates_total);
   }
   
   //
   //
   //
   //
   //
   
      double alphs = 2.0/(SignalSmooth+1.0);
      double alpha = 2.0/(RmoSmooth+1.0);
      
      //
      //
      //
      //
      //
 
      static cPrice _price; _price.setTotal(rates_total);
      for (int i=(int)MathMax(prev_calculated-1,0); i<rates_total; i++)
      {
         prices[i] = _price.getPrice(Price,i);
            double thigh  = prices[i];
            double tlow   = prices[i];
            double tprice = prices[i];
            double price  = tprice;
            double sum    = 0;
            
               for (int k=1; k<=Depth && (i-k-1)>=0; k++)
               {
                  thigh           = MathMax(prices[i-k-1],thigh);
                  tlow            = MathMin(prices[i-k-1],tlow);
                  pBuffer[i][k-1] = price;
                  if (i>=MaLength)
                  {
                     price = 0; for (int j=0; j<MaLength && (i-j)>=0; j++) price += pBuffer[i-j][k-1];
                                                                           price /= (double)MaLength;
                  }
                  sum += price;
               }
      
            //
            //
            //
            //
            //
      
            if ((thigh-tlow) != 0)
                  work[i][0] = 100*(tprice-sum/(double)Depth)/(thigh-tlow);
            else  work[i][0] = 0;
            if (i>0)
            {
               work[i][1]     = work[i-1][1];
               colorBuffer[i] = colorBuffer[i-1];
               rmo[i]         = rmo[i-1]+alpha*(work[i][0]-rmo[i-1]);
                  if (SignaLinesVisible)
                  {
                     rmoSignal1[i] = rmoSignal1[i-1]+alphs*(work[i][0]   -rmoSignal1[i-1]);
                     rmoSignal2[i] = rmoSignal2[i-1]+alphs*(rmoSignal1[i]-rmoSignal2[i-1]);
                  }
                  else
                  {
                     rmoSignal1[i] = EMPTY_VALUE;
                     rmoSignal2[i] = EMPTY_VALUE;
                  }
            
                  //
                  //
                  //
                  //
                  //
            
                  if (rmo[i]>rmo[i-1]) work[i][1] =  1;
                  if (rmo[i]<rmo[i-1]) work[i][1] = -1;
                  if (rmo[i]>0 && work[i][1]== 1)  colorBuffer[i] = 0;
                  if (rmo[i]>0 && work[i][1]==-1)  colorBuffer[i] = 1;
                  if (rmo[i]<0 && work[i][1]==-1)  colorBuffer[i] = 2;
                  if (rmo[i]<0 && work[i][1]== 1)  colorBuffer[i] = 3;
            }
            rmoLine[i] = rmo[i];
      }
   return(rates_total);
}
 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

class cPrice
{
private:
   double doGetPrice(ENUM_APPLIED_PRICE price, string symbol, ENUM_TIMEFRAMES timeFrame, int position);
   int    totalRates;

   //
   //
   //
   //
   //
  
public:
   void   cPrice()            { totalRates = 0;     }
   void   setTotal(int total) { totalRates = total; }
   double getPrice(ENUM_APPLIED_PRICE price,int position)                                           { return(doGetPrice(price,_Symbol,_Period,position)); }
   double getPrice(ENUM_APPLIED_PRICE price,ENUM_TIMEFRAMES timeFrame, int position)                { return(doGetPrice(price,_Symbol,timeFrame,position)); }
   double getPrice(ENUM_APPLIED_PRICE price,string symbol, int position)                            { return(doGetPrice(price,symbol,_Period,position)); }
   double getPrice(ENUM_APPLIED_PRICE price,string symbol, ENUM_TIMEFRAMES timeFrame, int position) { return(doGetPrice(price,symbol,timeFrame,position)); }
};

//
//
//
//
//

double cPrice::doGetPrice(ENUM_APPLIED_PRICE price, string symbol, ENUM_TIMEFRAMES timeFrame, int position)
{
   MqlRates _rates[]; int copyCount;
 
   //
   //
   //
   //
   //
   
   if (totalRates>0)
         copyCount = CopyRates(symbol,timeFrame,totalRates-position-1,1,_rates);
   else  copyCount = CopyRates(symbol,timeFrame,position             ,1,_rates);
   if (copyCount==1)
   {
      switch (price)
      {
         case PRICE_CLOSE:    return(_rates[0].close);
         case PRICE_HIGH:     return(_rates[0].high);
         case PRICE_LOW:      return(_rates[0].low);
         case PRICE_OPEN:     return(_rates[0].open);
         case PRICE_MEDIAN:   return((_rates[0].high+_rates[0].low)/2.0);
         case PRICE_TYPICAL:  return((_rates[0].high+_rates[0].low+_rates[0].close)/3.0);
         case PRICE_WEIGHTED: return((_rates[0].high+_rates[0].low+_rates[0].close+_rates[0].close)/4.0);
         default: return(0);
      }            
   }
   return(0);
}